/**
 * @copyright Copyright (c) Open-Xchange GmbH, Germany <info@open-xchange.com>
 * @license AGPL-3.0
 *
 * This code is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with OX App Suite. If not, see <https://www.gnu.org/licenses/agpl-3.0.txt>.
 *
 * Any use of the work other than as authorized under this license or copyright law is prohibited.
 */

const { I } = inject()

module.exports = {

  editWindow: '.io-ox-tasks-edit-window',

  newTask () {
    I.clickPrimary('New task')
    I.waitForElement('.io-ox-tasks-edit')
  },
  editTask () {
    I.clickToolbar('Edit')
    I.waitForElement('.io-ox-tasks-edit')
  },
  async selectTask (id) {
    const item = locate('.vgrid-cell').withText(id).as(id)
    I.waitForElement(item)
    I.click(item)
    await I.waitForFocus('.vgrid-cell.selected')
  },
  create () {
    I.click('Create')
    I.waitForDetached('.io-ox-tasks-edit-window')
    I.waitForElement('.vgrid-cell.selected.tasks')
    I.waitForElement('.tasks-detailview')
  },
  save () {
    I.click('Save')
    I.waitForDetached('.io-ox-tasks-edit-window')
    I.waitForElement('.vgrid-cell.selected.tasks')
    I.waitForElement('.tasks-detailview')
  },
  selectAll () {
    I.waitForElement('.selectable.tasks')
    I.click('.dropdown', '~Tasks toolbar')
    I.clickDropdown('Select all')
  }
}
