import { describe, it, expect } from 'vitest'
import { build } from 'vite'

import vitePluginOxManifests from '../../dist/index'
import { getFileFromBundle } from '../util'

const __dirname = import.meta.dirname

describe('Meta option', () => {
  it('works', async () => {
    const bundle = await build({
      root: __dirname,
      logLevel: 'silent',
      build: { write: false, rollupOptions: { input: {} } },
      plugins: [vitePluginOxManifests({
        meta: {
          version: '1.2.3'
        }
      })]
    })

    const metaFile = getFileFromBundle('meta.json', bundle)
    expect(JSON.parse(metaFile.source)).toEqual({ version: '1.2.3' })
  })
})
